@echo off
set versionnum=14

if not exist ./OutlastLauncher.exe (
	powershell write-host -fore Red script is not installed in the correct directory.
	TIMEOUT /T 3 /nobreak > NUL
	exit /b
)

if not exist ".\backup" (
	powershell write-host -fore Red Backup folder not detected, creating folder.
	mkdir .\backup\
	powershell write-host -fore Green Backup folder created.
	echo.
)

if not exist ".\backup\Config\" mkdir .\backup\Config\
if not exist ".\backup\Localization\" mkdir .\backup\Localization\
if not exist ".\backup\Movies\" mkdir .\backup\Movies\
if not exist ".\backup\SaveData\" mkdir .\backup\SaveData\
if not exist ".\PlayerModels\" mkdir .\PlayerModels\
if not exist ".\PlayerModels\Configs\" (
	mkdir .\PlayerModels\Configs\BaseGame
	robocopy .\OLGame\config\ .\PlayerModels\Configs\BaseGame\ DefaultGame.ini > nul
	mkdir .\PlayerModels\Configs\PlayerModelGame
	robocopy .\OLGame\config\ .\PlayerModels\Configs\PlayerModelGame\ DefaultGame.ini > nul
)

if not exist ".\custom" (
	powershell write-host -fore Red Custom Campaign folder not detected, creating folder.
	mkdir .\custom\
	powershell write-host -fore Green Custom Campaign folder created.
	echo.
)

if not exist ".\OLGame\CookedPCConsole\Custom" (
	powershell write-host -fore Red Custom map folder not detected, creating folder.
	mkdir .\OLGame\CookedPCConsole\Custom\
	powershell write-host -fore Green Custom Campaign folder created.
	echo.
)


for /F %%D in ('curl -s -L https://www.dropbox.com/s/k9ape2paz79qjbu/Version.txt') do if %%D gtr %versionnum% (
	powershell write-host -fore yellow An update is available.
	powershell write-host -fore yellow To update, type [Update]
	echo.
)

if not "%1"=="" (
	set Command=Play %1
	Goto Com-Play
)

powershell write-host -fore Blue For a list of commands type [Help]
powershell write-host -fore Blue If the script fails to mount a custom campaign, please run the script as admin.
goto Input

:Input
	Echo.
	set /p Command=^> 
	Echo.
	findstr /ri /c:"^ *:Com-%Command% " /c:"^ *:Com-%Command%$" "%~f0" >nul 2>nul && goto Com-%Command%
	for /f "tokens=1" %%i in ("%Command%") do if /I "%%i"=="Open" goto Com-Open 
	for /f "tokens=1" %%i in ("%Command%") do if /I "%%i"=="Play" goto Com-Play
	for /f "tokens=1" %%i in ("%Command%") do if /I "%%i"=="make" goto Com-Make
	for /f "tokens=1" %%i in ("%Command%") do if /I "%%i"=="Mount" goto Com-Mount
	
	REM Below is the set of instructions to run if the command does not work. 
	powershell write-host -fore Red Command Not Found
	goto Input

:Com-List
	REM for %%f in (".\OLGame\CookedPCConsole\Custom\*.udk") do powershell write-host -fore Blue %%~nf
	for %%f in (".\OLGame\CookedPCConsole\Custom\*") do (
			powershell write-host -fore Blue %%~nf
		)
	goto Input
	
:Com-Open
	REM Get second word from inputted command, and use that as the level name
	for /f "tokens=2" %%i in ("%Command%") do set Level=%%i
	
	if exist .\OLGame\CookedPCConsole\Custom\%level%.udk (
		powershell write-host -fore Green Successfully loaded level
		.\Binaries\Win64\OLGame.exe Custom\%level% -log -nosteam
		goto Input
	)
	REM Run if not found
	powershell write-host -fore Red Level Not found
	goto Input
	
:Com-Help
	powershell write-host -fore Blue Open
	powershell write-host -fore Yellow Used to open maps. 
	powershell write-host -fore Yellow Syntax: Open [Map]
	powershell write-host -fore Blue Play
	powershell write-host -fore Yellow Used to run custom campaigns
	powershell write-host -fore Yellow Syntax: Play [Campaign]
	powershell write-host -fore Blue Make
	powershell write-host -fore Yellow Makes a folder with the correct directorys for a custom campaign.
	powershell write-host -fore Yellow Syntax: Make [Campaign Name] [Config{true/false}] [Localization{True/false}] [Content{True/False}]
	powershell write-host -fore Blue List
	powershell write-host -fore Yellow Prints a list of currently installed custom maps. 
	powershell write-host -fore Yellow Syntax: List
	powershell write-host -fore Blue Update
	powershell write-host -fore Yellow Checks for an update, and updates the batch script if one is available.
	powershell write-host -fore Yellow Syntax: Update
	powershell write-host -fore Blue Exit
	powershell write-host -fore Yellow Stops running this script
	powershell write-host -fore Yellow Syntax: Exit
	powershell write-host -fore Blue Mount
	powershell write-host -fore Yellow Mounts a player model stored in the PlayrModels directory.
	powershell write-host -fore Yellow Syntax: Mount [PlayerModel]
	powershell write-host -fore Blue Unmount
	powershell write-host -fore Yellow Unmounts the currently mounted playermodel, and restores the config files.
	powershell write-host -fore Yellow Syntax: Unmount
	powershell write-host -fore Blue Mounthelp
	powershell write-host -fore Yellow Displays a guide on how to set up the Player Model Mounter.
	powershell write-host -fore Yellow Syntax: Mounthelp
	goto Input
	
:Com-Exit
	Exit

:Com-Play

	for /f "tokens=2" %%i in ("%Command%") do set Game=%%i
	
	if not exist .\Custom\%Game%\ (
		powershell write-host -fore Red Campaign Not found
		powershell write-host -fore Red Please ensure you havent made a typo.
		if not "%1"=="" (
			exit /b
		)
		goto input
	)
	
	if not exist .\Custom\%Game%\config.ini (
		powershell write-host -fore red Campaign is missing config file
		if not "%1"=="" (
			exit /b
		)
		goto input
	)
		
	Rem Reset variables
	set config=False
	set Localization=False
	set Content=False
	set Movies=false
	
	Rem Read from config file
	for /f "tokens=1,2 delims==" %%a in (.\Custom\%Game%\config.ini) do (
		if /I %%a==Config set Config=%%b 
		if /I %%a==Localization set Localization=%%b
		if /I %%a==Content set Content=%%b
		if /I %%a==SaveData set SaveData=%%b
	)
			
	Rem Mount Game
	if /I %Content%==true (
		call
		powershell write-host -fore Blue Mounting Game Content
		mklink /J .\OLGame\CookedPCConsole\Custom\Campaign\ .\Custom\%Game%\Content > nul
	)
	Rem Mount Config files
	if /I %Config%==true (
		powershell write-host -fore Blue Mounting Config Files
		robocopy /MIR .\OLGame\Config\ .\Backup\Config\ > nul
		robocopy .\Custom\%Game%\Config\ .\OLGame\Config\ > nul
	)
			
	Rem Mount Localization Files
	if /I %Localization%==true (
		powershell write-host -fore Blue Mounting Localization Files
		robocopy /MIR .\OLGame\Localization\ .\Backup\Localization\ > nul
		robocopy /e .\Custom\%Game%\Localization\ .\OLGame\Localization\ > nul
	)
	
	Rem Mount Movie Files
	if /I %Movies%==true (
		powershell write-host -fore Blue Mounting Movie Files
		robocopy .\OLGame\Movies\ .\Backup\Movies\ > nul
		robocopy .\Custom\%Game%\Movies\ .\OLGame\Movies\ > nul
	)
			
	Rem Mount Save Data
	if /I %SaveData%==true (
		if not exist .\custom\%game%\SaveData\ (
			powershell write-host -fore Blue Savegame folder not found, creating
			mkdir .\custom\%game%\SaveData\
		)
		powershell write-host -fore Blue Mounting Save Data
		robocopy /MIR .\OLGame\SaveData\ .\Backup\SaveData > nul
		robocopy /MIR .\Custom\%Game%\SaveData\ .\OLGame\SaveData\ > nul
	)
			
	Rem Launch the game using the newly mounted file. 
	powershell write-host -fore Green Content mounted
	.\Binaries\Win32\OLGame.exe -NOSTEAM -NOHOMEDIR -log
			
		Rem Restore config files from backup
	if /I %config%==true (
		powershell write-host -fore Blue Restoring Config Files
		robocopy .\Backup\Config .\OLGame\Config > nul
	)
			
	Rem Restore localization from backup
	if /I %Localization%==true (
		powershell write-host -fore Blue Restoring Localization
		robocopy /MIR .\Backup\Localization\ .\OLGame\Localization\ > nul
	)
	
	Rem Restore Movies from backup
	if /I %Movies%==true (
		powershell write-host -fore Blue Restoring Movies
		robocopy .\Backup\Movies\ .\OLGame\Movies\ > nul
	)
		
	if /I %SaveData%==true (
		Rem Copy Savefiles over to the mod folder, then restore the save files from backup.
		powershell write-host -fore Blue Updating Save Data
		robocopy /MIR .\OLGame\SaveData\ .\Custom\%Game%\SaveData\ > nul
		robocopy /MIR .\Backup\SaveData\ .\OLGame\SaveData\ > nul
	)

	Rem Unmount Game Content
	if /I %Content%==true (
		powershell write-host -fore Blue Unmounting Game Content
		rmdir .\OLGame\CookedPCConsole\Custom\Campaign\
	)

	if not "%1"=="" (
		exit /b
	)

	goto Input
	REM Run if not found

:Com-Make
	
	set Config=false
	set Localization=false
	set Content=false
	set Movies=false
	
	for /f "tokens=2" %%i in ("%Command%") do set Name=%%i
	
	for /f "tokens=3" %%i in ("%Command%") do (
		if %%i==true set Config=true
		if %%i==True set Config=true
	)
	
	for /f "tokens=4" %%i in ("%Command%") do (
		if %%i==true set Localization=true
		if %%i==True set Localization=true
	)
	
	for /f "tokens=5" %%i in ("%Command%") do (
		if %%i==true set Content=true
		if %%i==True set Content=true
	)
	
	if exist ".\Custom\%name%" (
		powershell write-host -fore Red A campaign with the same name already exists.
		goto input
	)
	
	rem Make Folder
	
	powershell write-host -fore Blue Making Campaign Folder
	mkdir .\Custom\%Name%
	
	powershell write-host -fore Blue Making Config File
	echo Configuration> .\Custom\%Name%\Config.ini
	
	if %config%==true (
		powershell write-host -fore Blue Making Config Folder
		mkdir .\Custom\%Name%\config
		echo Config=true >> .\Custom\%Name%\Config.ini
	)
	
	if %Localization%==true (
		powershell write-host -fore Blue Making Localization Folder
		mkdir .\Custom\%Name%\Localization
		echo Localization=true >> .\Custom\%Name%\Config.ini
	)
	
	if %Movies%==true (
		powershell write-host -fore Blue Making Movies Folder
		mkdir .\Custom\%Name%\Movies
		echo Movies=true >> .\Custom\%Name%\Config.ini
	)
	
	if %Content%==true (
		powershell write-host -fore Blue Making Content Folder
		mkdir .\Custom\%Name%\Content
		echo Content=true >> .\Custom\%Name%\Config.ini
	)
	
	goto input
	
:Com-Mount

	for /f "tokens=2" %%i in ("%Command%") do set Game=%%i
	
	if Game==Configs (
	powershell write-host -fore Red Very Funny,
	goto input
	)
	
	if not exist ".\PlayerModels\%Game%\" (
		powershell write-host -fore Red Player Model Not found
		powershell write-host -fore Red Please ensure you havent made a typo.
		goto input
	)
	
	if exist ".\OLGame\CookedPCConsole\Custom\PlayerModel\" (
		rmdir .\OLGame\CookedPCConsole\Custom\PlayerModel\
	)
	robocopy .\PlayerModels\Configs\PlayerModelGame\ .\OLGame\config\ DefaultGame.ini > nul
	mklink /J .\OLGame\CookedPCConsole\Custom\PlayerModel\ .\PlayerModels\%Game%\Content > nul
	robocopy .\PlayerModels\%Game%\Config .\OLGame\config\ DefaultPlayerModel.ini > nul
	powershell write-host -fore Green Player Model Mounted
	goto input
	
:Com-Unmount

	rmdir .\OLGame\CookedPCConsole\Custom\PlayerModel\
	robocopy .\PlayerModels\Configs\BaseGame\ .\OLGame\config\ DefaultGame.ini > nul
	powershell write-host -fore Green Player Model Unmounted
	goto input
	
:Com-MountHelp
	powershell write-host -fore Blue In order to mount Player models you must make a few changes to one file. 
	powershell write-host -fore Blue Navigate into the Playermodels folder that the script created. 
	powershell write-host -fore Blue Then go into the config folder, and inside the PlayerModelGame folder
	powershell write-host -fore Blue should be a file named DefaultGame.ini
	echo.
	powershell write-host -fore Blue Open the file, and replace the lines under [Engine.GameInfo] with the following.
	echo.
	powershell write-host -fore Yellow DefaultGame=OLCustomPlayerModelSDK.OLCustomGame
	powershell write-host -fore Yellow DefaultServerGame=OLCustomPlayerModelSDK.OLCustomGame
	powershell write-host -fore Yellow PlayerControllerClassName=OLGame.OLPlayerController
	powershell write-host -fore Yellow DefaultGameType="OLCustomPlayerModelSDK.OLCustomGame"
	echo.
	powershell write-host -fore Blue Now you should be ready to mount the files. 
	
	goto input
:Com-Update
for /F %%D in ('curl -s -L https://www.dropbox.com/s/k9ape2paz79qjbu/Version.txt') do if "%%D" gtr "%versionnum%" (curl -s -L -O https://www.dropbox.com/s/jd0q9f3mc74jxmv/Level_Launcher.Bat && cls && %0) else (powershell write-host -fore Blue No Update Required && goto Input)